<script lang="ts">
  import { Toggle, Input, InputAddon, ButtonGroup } from 'flowbite-svelte';
  import Spinner from "$lib/components/ui-elements/Spinner.svelte";
  import Badge from '$lib/components/ui-elements/Badge.svelte';
  import EventTeams from '$lib/components/ui-elements/EventTeams.svelte';
  import Dropdown from '$lib/components/ui-elements/Dropdown.svelte';
  import TeamDataExport from '$lib/components/ui-elements/TeamDataExport.svelte';
  import {
    graphql,
    GetAllRegionsStore,
    GetAllEventGroupsStore,
    GetEventsByEventGroupIdStore,
    GetTeamsByEventId$result,
    GetTeamsByEventIdStore,
  } from "$houdini";
  import Env from '$lib/Env';
  import type { DeepWriteable, Event, EventGroup, EventGroupTeam } from '$lib/graphql/types';
  import ExistingTeamCardSubscribe from '$lib/components/ui-elements/ExistingTeamCardSubscribe.svelte';
  import HeaderWithBackdrop from '$lib/components/ui-elements/HeaderWithBackdrop.svelte';
  import Alert from '$lib/components/ui-elements/Alert.svelte';
  import { Button } from "flowbite-svelte";
  import { hasApiRole } from "$lib/components/layout/data/nav-tabs";
  import { authTokenParsed } from "$stores/authStore";

  const getTeamsWhereQuery = graphql(`
    query GetUnregisteredTeamsWhere(
      $team_min: Int = 0,
      $team_max: Int = 999,
      $regions: [String!] = ["northwest","northeast","southwest","southeast","midwest","invitational","east","west"]
    ) {
      teams(
        order_by: { created: asc },
        where: {
          event_registration_aggregate: { count: { predicate: { _eq: 0 } } },
          team_size: { _gte: $team_min, _lte: $team_max },
          institution: {regions: {region: {name: {_in: $regions}}}}
        }
      ) {
        id
        name
        long_name
        team_size
        institution {
          name
          regions {
            region {
              name
            }
          }
        }
      }
    }
  `)

  // Lookup table to allow verbose option naming
  let eventGroupByName: Record<string, any> = {};
  let eventByName: Record<string, any> = {};

  // Option names
  let eventGroupOptions: string[] = [];
  let eventOptions: string[] = [];
  let regionOptions: string[] = [];

  // Selection vars
  let selectedEventGroup: string[] = [];
  let selectedEvents: string[] = [];
  let selectedRegions: string[] = [];

  // Houdini / GQL interfaces
  const eventGroupsStore = new GetAllEventGroupsStore();
  const eventStore = new GetEventsByEventGroupIdStore();
  const regionStore = new GetAllRegionsStore();

  async function fetchEventGroups() {
    await eventGroupsStore.fetch();
    console.log("fetched event groups")
  }

  async function fetchEvents(event_group_id: string | undefined) {
    if (!event_group_id) {
      return [];
    }
    await eventStore.fetch(
      { variables: { event_group_id } }
    );
    eventOptions = [];
    for (let entry of $eventStore.data?.events || []) {
      const key = entry.name + " - " + entry.start.toLocaleDateString()
      eventByName[key] = entry;
      eventOptions.push(key);
    }
  }

  async function fetchRegions() {
    await regionStore.fetch();
    console.log($regionStore.data)
    return regionOptions = ($regionStore.data?.regions || []).map(re => re.name)
  }

  // Auto update when event group info is updated
  $: if ($eventGroupsStore.data?.event_groups) {
    eventOptions = [];
    eventGroupOptions = [];
    for (let eg of $eventGroupsStore.data.event_groups) {
      eventGroupByName[eg.name] = eg;
      eventGroupOptions.push(eg.name);
    }
  }

  let minTeamMembers = 0;
  let maxTeamMembers = 999;
  let hideControls = true;
  let showUnregistered = false;
</script>

<div class="flex flex-col items-center gap-1">
  <div class="flex flex-row items-center gap-2 z-100 text-center sticky md:top-[80px] bg-white pb-3">
    <Toggle on:change={() => {showUnregistered = !showUnregistered}} checked={showUnregistered}>
      Show Unregistered
    </Toggle>
    {#await fetchEventGroups()}
      <Spinner />
    {:then _}
      <Dropdown
        class="m-1"
        title="Event Group"
        options={eventGroupOptions}
        on:select={() => (selectedEvents = [])}
        bind:selectedOptions={selectedEventGroup} />
      {#if selectedEventGroup[0]}
        {#await fetchEvents(eventGroupByName[selectedEventGroup[0]].id) then _}
          <Dropdown
            class="m-1"
            title="Event"
            multiple
            options={eventOptions}
            bind:selectedOptions={selectedEvents} />
        {/await}
      {/if}
    {:catch e}
      <pre>{e?.message || JSON.stringify(e, null, 2)}</pre>
    {/await}
  </div>
  {#if showUnregistered}
    <div class="flex flex-row items-center gap-1">
      <div>Unregistered filters</div>
      <ButtonGroup class="min-w-24 max-w-32">
        <InputAddon>
          Team Min
        </InputAddon>
        <Input bind:value={minTeamMembers}/>
      </ButtonGroup>
      <ButtonGroup class="min-w-24 max-w-32">
        <InputAddon>
          Team Max
        </InputAddon>
        <Input bind:value={maxTeamMembers}/>
      </ButtonGroup>
      {#await fetchRegions()}
        <Spinner />
      {:then _}
        <Dropdown
          class="m-1"
          title="Regions"
          multiple
          options={regionOptions}
          bind:selectedOptions={selectedRegions} />
      {/await}
    </div>
  {/if}
</div>

{#if showUnregistered}
  <div class="p-2 px-8">
    <HeaderWithBackdrop class="2xl:container mx-auto col-span-full -z-10" size="sm" wrap>
      Unregistered Teams
    </HeaderWithBackdrop>
    <Alert class="2xl:container mx-auto col-span-full text-center">
      These teams have been created but are not yet registered for an event.
    </Alert>
    {#await getTeamsWhereQuery.fetch(
      { variables: {
        team_min: Number(minTeamMembers),
        team_max: Number(maxTeamMembers),
        regions: selectedRegions
      }}
    )}
      <Spinner />
    {:then unregistered}
      <div class="flex flex-row items-center">
        <span class="font-bold">
          Displaying {(unregistered.data?.teams || []).length} unregistered teams
        </span>
        {#if hasApiRole($authTokenParsed, 'staff') && unregistered.data && (unregistered.data.teams || []).length}
          <div class="pl-1 py-1">
            <TeamDataExport teamIds={unregistered.data.teams.map((v) => v.id)} filename="Unregistered Teams" />
          </div>
        {/if}
      </div>
      <div class="grid grid-flow-row grid-cols-1 md:grid-cols-[repeat(auto-fit,_minmax(500px,_1fr))] gap-3 pb-5 mx-auto px-10">
        {#each unregistered.data?.teams || [] as team}
          <ExistingTeamCardSubscribe teamId={team.id} background="" {hideControls} />
        {/each}
      </div>
    {/await}
  </div>
{/if}

{#each selectedEvents as event}
  <div class="p-2">
    <div class="col-span-full flex py-5 items-center">
      <span class="flex-shrink text-2xl text-gray-500 italic font-light">
        {event}

        {#if hasApiRole($authTokenParsed, 'event_admin')}
          <Button class="ml-3 py-1" color="green" href="/staff/deployment/event/{eventByName[event].id}">
            <span class="hover:animate-spin">🚀 Deploy Event 🚀</span>
          </Button>
        {/if}
      </span>
      <div class="ml-2 flex-grow border-t border-gray-400" />
    </div>
    <EventTeams
      eventId={eventByName[event].id}
      eventName={eventByName[event].name}
      {hideControls}
      background=""
      showExportButton={hasApiRole($authTokenParsed, 'staff')}
    />
  </div>
{/each}
